// Copyright Bruno Dutra 2015-2016
// Distributed under the Boost Software License, Version 1.0.
// See accompanying file LICENSE.txt or copy at http://boost.org/LICENSE_1_0.txt

#include <metal/list/front.hpp>
#include <metal/list/list.hpp>
#include <metal/lambda/lambda.hpp>
#include <metal/lambda/invoke.hpp>
#include <metal/number/number.hpp>

#include "test.hpp"

#define MATRIX(M, N) \
    CHECK((metal::is_invocable<metal::lambda<metal::front>, VAL(M)>), (FALSE)); \
    CHECK((metal::is_invocable<metal::lambda<metal::front>, NUM(M)>), (FALSE)); \
    CHECK((metal::is_invocable<metal::lambda<metal::front>, PAIR(M)>), (TRUE)); \
    CHECK((metal::is_invocable<metal::lambda<metal::front>, LIST(M)>), (BOOL(M > 0))); \
    CHECK((metal::is_invocable<metal::lambda<metal::front>, MAP(M)>), (BOOL(M > 0))); \
    CHECK((metal::is_invocable<metal::lambda<metal::front>, LBD(M)>), (FALSE)); \
    CHECK((metal::is_invocable<metal::lambda<metal::front>, LBD(_)>), (FALSE)); \
    CHECK((metal::front<PAIR(M)>), (NUM(M))); \
    CHECK((metal::front<LIST(INC(M))>), (VAL(0))); \
    CHECK((metal::front<MAP(INC(M))>), (PAIR(0))); \
/**/

GEN(MATRIX)

